4 USAGE='<fetch-options> <repository> <refspec>...'
7 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
24 while case "$#" in 0) break ;; esac
27 -a|--a|--ap|--app|--appe|--appen|--append)
30 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
31 --upload-pa|--upload-pac|--upload-pack)
36 -f|--f|--fo|--for|--forc|--force)
39 -t|--t|--ta|--tag|--tags)
42 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
45 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
46 --update-he|--update-hea|--update-head|--update-head-|\
47 --update-head-o|--update-head-ok)
53 -k|--k|--ke|--kee|--keep)
57 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
71 origin=$(get_default_remote)
72 test -n "$(get_remote_url ${origin})" ||
73 die "Where do you want to fetch from today?"
74 set x $origin ; shift ;;
78 remote=$(get_remote_url "$@")
81 rsync_slurped_objects=
83 rloga="$rloga $remote_nick"
84 test "$remote_nick" = "$remote" || rloga="$rloga $remote"
86 if test "" = "$append"
88 : >"$GIT_DIR/FETCH_HEAD"
91 append_fetch_head () {
98 t) not_for_merge_='not-for-merge' ;;
99 '') not_for_merge_= ;;
102 # remote-nick is the URL given on the command line (or a shorthand)
103 # remote-name is the $GIT_DIR relative refs/ path we computed
106 # the $note_ variable will be fed to git-fmt-merge-msg for further
108 case "$remote_name_" in
112 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
113 note_="branch '$note_' of " ;;
115 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
116 note_="tag '$note_' of " ;;
118 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
119 note_="remote branch '$note_' of " ;;
121 note_="$remote_name of " ;;
123 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
125 note_="$note_$remote_"
127 # 2.6.11-tree tag would not be happy to be fed to resolve.
128 if git-cat-file commit "$head_" >/dev/null 2>&1
130 headc_=$(git-rev-parse --verify "$head_^0") || exit
131 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
132 [ "$verbose" ] && echo >&2 "* committish: $head_"
133 [ "$verbose" ] && echo >&2 " $note_"
135 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
136 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
137 [ "$verbose" ] && echo >&2 " $note_"
139 if test "$local_name_" != ""
141 # We are storing the head locally. Make sure that it is
142 # a fast forward (aka "reverse push").
143 fast_forward_local "$local_name_" "$head_" "$note_"
147 fast_forward_local () {
148 mkdir -p "$(dirname "$GIT_DIR/$1")"
151 # Tags need not be pointing at commits so there
152 # is no way to guarantee "fast-forward" anyway.
153 if test -f "$GIT_DIR/$1"
155 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
157 [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
159 echo >&2 "* $1: updating with $3"
160 git-update-ref -m "$rloga: updating tag" "$1" "$2"
163 echo >&2 "* $1: storing $3"
164 git-update-ref -m "$rloga: storing tag" "$1" "$2"
168 refs/heads/* | refs/remotes/*)
169 # $1 is the ref being updated.
170 # $2 is the new value for the ref.
171 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
174 # Require fast-forward.
175 mb=$(git-merge-base "$local" "$2") &&
178 if test -n "$verbose"
180 echo >&2 "* $1: same as $3"
184 echo >&2 "* $1: fast forward to $3"
185 echo >&2 " from $local to $2"
186 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
192 echo >&2 "* $1: does not fast forward to $3;"
193 case ",$force,$single_force," in
195 echo >&2 " forcing update."
196 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
199 echo >&2 " not updating."
205 echo >&2 "* $1: storing $3"
206 git-update-ref -m "$rloga: storing head" "$1" "$2"
212 case "$update_head_ok" in
214 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
218 # If --tags (and later --heads or --all) is specified, then we are
219 # not talking about defaults stored in Pull: line of remotes or
220 # branches file, and just fetch those and refspecs explicitly given.
221 # Otherwise we do what we always did.
223 reflist=$(get_remote_refs_for_fetch "$@")
228 git-ls-remote $upload_pack --tags "$remote" ||
240 if git-check-ref-format "$name"
242 echo ".${name}:${name}"
244 echo >&2 "warning: tag ${name} ignored"
249 # remote URL plus explicit refspecs; we need to merge them.
250 reflist="$reflist$LF$taglist"
252 # No explicit refspecs; fetch tags only.
265 # These are relative path from $GIT_DIR, typically starting at refs/
267 if expr "z$ref" : 'z\.' >/dev/null
270 ref=$(expr "z$ref" : 'z\.\(.*\)')
274 if expr "z$ref" : 'z+' >/dev/null
277 ref=$(expr "z$ref" : 'z+\(.*\)')
281 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
282 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
284 rref="$rref$LF$remote_name"
286 # There are transports that can fetch only one head at a time...
288 http://* | https://* | ftp://*)
289 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
294 head="ref: $remote_name"
295 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
297 remote_name_quoted=$(@@PERL@@ -e '
300 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
303 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
304 depth=$( expr \( $depth + 1 \) )
306 expr "z$head" : "z$_x40\$" >/dev/null ||
307 die "Failed to fetch $remote_name from $remote"
308 echo >&2 Fetching "$remote_name from $remote" using http
309 git-http-fetch -v -a "$head" "$remote/" || exit
312 TMP_HEAD="$GIT_DIR/TMP_HEAD"
313 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
314 head=$(git-rev-parse --verify TMP_HEAD)
316 test "$rsync_slurped_objects" || {
317 rsync -av --ignore-existing --exclude info \
318 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
320 # Look at objects/info/alternates for rsync -- http will
321 # support it natively and git native ones will do it on
322 # the remote end. Not having that file is not a crime.
323 rsync -q "$remote/objects/info/alternates" \
324 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
325 rm -f "$GIT_DIR/TMP_ALT"
326 if test -f "$GIT_DIR/TMP_ALT"
328 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
331 case "$alt" in 'bad alternate: '*) die "$alt";; esac
332 echo >&2 "Getting alternate: $alt"
333 rsync -av --ignore-existing --exclude info \
334 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
336 rm -f "$GIT_DIR/TMP_ALT"
338 rsync_slurped_objects=t
342 # We will do git native transport with just one call later.
346 append_fetch_head "$head" "$remote" \
347 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
352 http://* | https://* | ftp://* | rsync://* )
353 ;; # we are already done.
355 ( : subshell because we muck with IFS
358 git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
360 while read sha1 remote_name
364 echo >&2 "Fetch failure: $remote"
392 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
393 append_fetch_head "$sha1" "$remote" \
394 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
401 fetch_main "$reflist"
403 # automated tag following
404 case "$no_tags$tags" in
408 # effective only when we are following remote branch
409 # using local tracking branch.
411 git-ls-remote $upload_pack --tags "$remote" |
412 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
415 test -f "$GIT_DIR/$name" && continue
416 git-check-ref-format "$name" || {
417 echo >&2 "warning: tag ${name} ignored"
420 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
421 echo >&2 "Auto-following $name"
422 echo ".${name}:${name}"
428 fetch_main "$taglist" ;;
432 # If the original head was empty (i.e. no "master" yet), or
433 # if we were told not to worry, we do not have to check.
434 case ",$update_head_ok,$orig_head," in
438 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
439 if test "$curr_head" != "$orig_head"
442 -m "$rloga: Undoing incorrectly fetched HEAD." \
444 die "Cannot fetch into the current branch."